# @HEADER
# ************************************************************************
#
#            TriBITS: Tribal Build, Integrate, and Test System
#                    Copyright 2013 Sandia Corporation
#
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# ************************************************************************
# @HEADER

##############################################################################
#
# CMake variable for use by Trilinos/TrilinosCouplings clients.
#
# Do not edit: This file was generated automatically by CMake.
#
##############################################################################


# Include guard
IF (TrilinosCouplings_CONFIG_INCLUDED)
  RETURN()
ENDIF()
SET(TrilinosCouplings_CONFIG_INCLUDED TRUE)

# Make sure CMAKE_CURRENT_LIST_DIR is usable
IF (NOT DEFINED CMAKE_CURRENT_LIST_DIR)
  GET_FILENAME_COMPONENT(_THIS_SCRIPT_PATH ${CMAKE_CURRENT_LIST_FILE} PATH)
  SET(CMAKE_CURRENT_LIST_DIR ${_THIS_SCRIPT_PATH})
ENDIF()


## ---------------------------------------------------------------------------
## Compilers used by Trilinos/TrilinosCouplings build
## ---------------------------------------------------------------------------

SET(TrilinosCouplings_CXX_COMPILER "/opt/ohpc/pub/mpi/mvapich2-gnu-ohpc/2.1/bin/mpicxx")

SET(TrilinosCouplings_C_COMPILER "/opt/ohpc/pub/mpi/mvapich2-gnu-ohpc/2.1/bin/mpicc")

SET(TrilinosCouplings_FORTRAN_COMPILER "/opt/ohpc/pub/mpi/mvapich2-gnu-ohpc/2.1/bin/mpif90")


## ---------------------------------------------------------------------------
## Compiler flags used by Trilinos/TrilinosCouplings build
## ---------------------------------------------------------------------------

## Set compiler flags, including those determined by build type
SET(TrilinosCouplings_CXX_FLAGS " -std=c++11 -fopenmp -O3")

SET(TrilinosCouplings_C_FLAGS " -fopenmp -O3")

SET(TrilinosCouplings_FORTRAN_FLAGS " -O3")

## Extra link flags (e.g., specification of fortran libraries)
SET(TrilinosCouplings_EXTRA_LD_FLAGS "-lgfortran")

## This is the command-line entry used for setting rpaths. In a build
## with static libraries it will be empty.
SET(TrilinosCouplings_SHARED_LIB_RPATH_COMMAND "-Wl,-rpath,/opt/ohpc/pub/libs/gnu/mvapich2/trilinos/12.4.2/lib")
SET(TrilinosCouplings_BUILD_SHARED_LIBS "ON")

SET(TrilinosCouplings_LINKER /bin/ld)
SET(TrilinosCouplings_AR /bin/ar)

## ---------------------------------------------------------------------------
## Set library specifications and paths
## ---------------------------------------------------------------------------

## List of package include dirs
SET(TrilinosCouplings_INCLUDE_DIRS "${CMAKE_CURRENT_LIST_DIR}/../../../include")

## List of package library paths
SET(TrilinosCouplings_LIBRARY_DIRS "${CMAKE_CURRENT_LIST_DIR}/../../../lib")

## List of package libraries
SET(TrilinosCouplings_LIBRARIES "trilinoscouplings;stokhos_muelu;stokhos_ifpack2;stokhos_amesos2;stokhos_tpetra;stokhos_sacado;stokhos;muelu-adapters;muelu-interface;muelu;locathyra;locaepetra;localapack;loca;noxepetra;noxlapack;nox;teko;stratimikos;stratimikosbelos;stratimikosaztecoo;stratimikosamesos;stratimikosml;stratimikosifpack;ifpack2-adapters;ifpack2;zoltan2;anasazitpetra;ModeLaplace;anasaziepetra;anasazi;belostpetra;belosepetra;belos;ml;ifpack;amesos2;amesos;galeri-xpetra;galeri;aztecoo;isorropia;xpetra-sup;xpetra;thyratpetra;thyraepetraext;thyraepetra;thyracore;epetraext;tpetraext;tpetrainout;tpetra;kokkostsqr;tpetrakernels;tpetraclassiclinalg;tpetraclassicnodeapi;tpetraclassic;triutils;zoltan;epetra;sacado;rtop;teuchoskokkoscomm;teuchoskokkoscompat;teuchosremainder;teuchosnumerics;teuchoscomm;teuchosparameterlist;teuchoscore;kokkosalgorithms;kokkoscontainers;kokkoscore")

## Specification of directories for TPL headers
SET(TrilinosCouplings_TPL_INCLUDE_DIRS "/opt/ohpc/pub/libs/gnu/mvapich2/hdf5/1.8.16/include;/usr/include;/opt/ohpc/pub/libs/gnu/mvapich2/boost/1.60.0/include")

## Specification of directories for TPL libraries
SET(TrilinosCouplings_TPL_LIBRARY_DIRS "")

## List of required TPLs
SET(TrilinosCouplings_TPL_LIBRARIES "/opt/ohpc/pub/libs/gnu/mvapich2/hdf5/1.8.16/lib/libhdf5.so;/usr/lib64/libz.so;/opt/ohpc/pub/libs/gnu/openblas/0.2.15/lib/libopenblas.so;/opt/ohpc/pub/libs/gnu/openblas/0.2.15/lib/libopenblas.so")

## ---------------------------------------------------------------------------
## MPI specific variables
##   These variables are provided to make it easier to get the mpi libraries
##   and includes on systems that do not use the mpi wrappers for compiling
## ---------------------------------------------------------------------------

SET(TrilinosCouplings_MPI_LIBRARIES "")
SET(TrilinosCouplings_MPI_LIBRARY_DIRS "")
SET(TrilinosCouplings_MPI_INCLUDE_DIRS "")
SET(TrilinosCouplings_MPI_EXEC "/opt/ohpc/pub/mpi/mvapich2-gnu-ohpc/2.1/bin/mpiexec")
SET(TrilinosCouplings_MPI_EXEC_MAX_NUMPROCS "4")
SET(TrilinosCouplings_MPI_EXEC_NUMPROCS_FLAG "-np")

## ---------------------------------------------------------------------------
## Set useful general variables
## ---------------------------------------------------------------------------

## The packages enabled for this project
SET(TrilinosCouplings_PACKAGE_LIST "TrilinosCouplings;Stokhos;MueLu;NOX;Teko;Stratimikos;Ifpack2;Zoltan2;Anasazi;Belos;ML;Ifpack;Amesos2;Amesos;Galeri;AztecOO;Isorropia;Xpetra;Thyra;ThyraTpetraAdapters;ThyraEpetraExtAdapters;ThyraEpetraAdapters;ThyraCore;EpetraExt;Tpetra;TpetraCore;TpetraTSQR;TpetraKernels;TpetraClassic;Triutils;Zoltan;Epetra;Sacado;RTOp;Teuchos;TeuchosKokkosComm;TeuchosKokkosCompat;TeuchosRemainder;TeuchosNumerics;TeuchosComm;TeuchosParameterList;TeuchosCore;KokkosAlgorithms;KokkosContainers;KokkosCore")

## The TPLs enabled for this project
SET(TrilinosCouplings_TPL_LIST "HDF5;Zlib;Boost;LAPACK;BLAS;MPI;Pthread")


# Include configuration of dependent packages
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Stokhos/StokhosConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../MueLu/MueLuConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../NOX/NOXConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Teko/TekoConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Stratimikos/StratimikosConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Ifpack2/Ifpack2Config.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Zoltan2/Zoltan2Config.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Anasazi/AnasaziConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Belos/BelosConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../ML/MLConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Ifpack/IfpackConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Amesos2/Amesos2Config.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Amesos/AmesosConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Galeri/GaleriConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../AztecOO/AztecOOConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Isorropia/IsorropiaConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Xpetra/XpetraConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Thyra/ThyraConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../ThyraTpetraAdapters/ThyraTpetraAdaptersConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../ThyraEpetraExtAdapters/ThyraEpetraExtAdaptersConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../ThyraEpetraAdapters/ThyraEpetraAdaptersConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../ThyraCore/ThyraCoreConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../EpetraExt/EpetraExtConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Tpetra/TpetraConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TpetraCore/TpetraCoreConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TpetraTSQR/TpetraTSQRConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TpetraKernels/TpetraKernelsConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TpetraClassic/TpetraClassicConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Triutils/TriutilsConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Zoltan/ZoltanConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Epetra/EpetraConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Sacado/SacadoConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../RTOp/RTOpConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../Teuchos/TeuchosConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosKokkosComm/TeuchosKokkosCommConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosKokkosCompat/TeuchosKokkosCompatConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosRemainder/TeuchosRemainderConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosNumerics/TeuchosNumericsConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosComm/TeuchosCommConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosParameterList/TeuchosParameterListConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../TeuchosCore/TeuchosCoreConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../KokkosAlgorithms/KokkosAlgorithmsConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../KokkosContainers/KokkosContainersConfig.cmake")
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../KokkosCore/KokkosCoreConfig.cmake")

# Import TrilinosCouplings targets
INCLUDE("${CMAKE_CURRENT_LIST_DIR}/TrilinosCouplingsTargets.cmake")
